
flock.firstrun =  { };

flock.firstrun.__defineGetter__("isFirstRun", function () {/*{{{*/
    var rval = flock_getBoolPref("flock.firstrun.completed");
    return !(rval==true);
});/*}}}*/

flock.firstrun.isFirstRunForComponent =  function (aComponentName) { /*{{{*/
    var key = "flock.firstrun.components." + aComponentName + ".completed";
    var rval = flock_getBoolPref(key);
    if(!(rval==true)) {
        flock_setBoolPref(key, true);
        return true;
    }
    return false;
}/*}}}*/

flock.firstrun.shutDownObserver =  {
    observe: function(aSubject, aTopic, aData) {
        flock_setBoolPref("flock.firstrun.completed", true);
    }
};

flock.xpcom.addObserver('quit-application-requested', flock.firstrun.shutDownObserver, false);
