// vim: foldmethod=marker
dojo.require("dojo.event");
flock.require("flock.common.popup");
flock.require("flock.common.rdf");
flock.require("flock.lucene.search");
flock.require('flock.favorites.favorites');
flock.require('flock.common.command');
//flock.require('flock.favorites');

//function flock_getProperty (aInput, aArcURI, aDS) {[>{{{<]
//    var node;
//    var RDF = flock_getRDFService();
//    var arc  = RDF.GetResource(aArcURI);
//    if (typeof(aInput) == "string") {
//        aInput = RDF.GetResource(aInput);
//    }
//    if (!aDS) {
//        node = flock_getFavoritesService().GetTarget(aInput, arc, true);
//    } 
//    else {
//        node = aDS .GetTarget(aInput, arc, true);
//    }
//    try {
//        return node.QueryInterface(Components.interfaces.nsIRDFResource).Value;
//    }
//    catch (e) {
//        return node ? node.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : "";
//    }    
//}[>}}}<]
//function flock_getCellText(aTree, aRow, aColName) {[>{{{<]
//    // Quick hack to allow this to grab from favorites OR history
//    var col = aTree.columns.getNamedColumn(aColName) || aTree.columns.getNamedColumn("h_" + aColName);
//    return aTree.view.getCellText(aRow, col);
//}[>}}}<]
//function flock_gotoAgg(aFeeds) {[>{{{<]
//    if (aFeeds.length == 1) {
//        var url = aFeeds[0];
//        var proto = url.substr(0, "http://".length).toLowerCase();

//        if (proto == "http://")
//            flock_goto("feed://" + url.substring("http://".length));
//        else
//            flock_goto("feed:" + url);
//    } else {
//        var outArr = new Array();
//        for (var i = 0;i < aFeeds.length;i++) {
//            outArr.push(escape(aFeeds[i]));
//        }

//        flock_goto("feeds:"+outArr.join("&"));   
//    }
//}[>}}}<]
//function flock_isFeed(aRsrc) {[>{{{<]
//    // test whether it is a feed
//    if (flock_getProperty(aRsrc, "http://home.netscape.com/NC-rdf#FeedURL")) {
//        return true;
//    }
//    return false;
//}[>}}}<]


// dnd handler for favorites tree/*{{{/
var favoriteDNDObserver = new DNDObserver();
favoriteDNDObserver.onDragStart = function (aEvent, aXferData, aDragAction) {
    var tree = aEvent.currentTarget;

    var selectedItems = flock_getTreeSelectionFromDrag(aEvent, tree, ["URL", "Name"], {filterChildren: false});
    if(!selectedItems) return false;
    var dataSet = new TransferDataSet();
    for (var i = 0; i < selectedItems.length; ++i) {
        var item = selectedItems[i];
        var data = new TransferData();
        data.addDataForFlavour("text/x-moz-url", item['URL']+"\n"+item['Name']);
        data.addDataForFlavour("text/html",      "<a href='"+item['URL']+"'>"+item['Name']+"</a>");
        data.addDataForFlavour("text/unicode",   item['URL']);
        dataSet.push(data);
    }
    aXferData.data = dataSet;
    
    if (aEvent.ctrlKey)
        aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
};/*}}}*/
favoriteDNDObserver.onDragStart = catchWrapper(favoriteDNDObserver.onDragStart);


function init() {/*{{{*/
    init_manager();
    init_left();
    init_right();
    init_commandHack();
    
}/*}}}*/

function init_commandHack() {/*{{{*/
    //dojo.event.connect(window, 'onfocus', function () {
    //    XXX('window', 'onfocus');
    //    document.commandDispatcher.updateCommands('focus');
    //});
    //dojo.event.connect(window, 'onselect', function () {
    //    XXX('window', 'onselect');
    //    document.commandDispatcher.updateCommands('select');
    //});
    //window.focus();
}/*}}}*/

function init_manager() {
    var collectionListBox = $('collectionListBox');
    var favTree = $('flock_favoriteView');

    var managerController = new CommandController({
        cmd_find: function () {/*{{{*/
            $('favoritesManagerSearchbox').focus();
        },/*}}}*/

        // XXX - BAD UI -- the following could either go here
        // or in the favoritesController... right now we aren't
        // being consistant.  MAKE THESE CONSISTENT!  - ja

        cmd_selectAllFavs: function () { /*{{{*/
            favTree.view.selection.selectAll();
        },/*}}}*/
        cmd_clearSelection: function () { /*{{{*/
            favTree.view.selection.clearSelection();
        },/*}}}*/ 
        cmd_collectionCreate: function () {/*{{{*/
            // create empty collection
            flock.favorites.createCollection();
        },/*}}}*/
    });

    window.controllers.appendController(managerController);
    // XXX - need to remove the managerController on unload
}

function init_left() {
    var collectionListBox = $('collectionListBox');
    var favTree = $('flock_favoriteView');
    
    // Controller Stuff
    // XXX DEBUG

    var collectionIsEditable = function () {/*{{{*/
        if (!collectionListBox.selectedItem) return false;
        return (collectionListBox.selectedItem.getAttribute('editable') != "false");
    };/*}}}*/
    var collectionHasFeeds = function () {/*{{{*/
        if (!collectionIsEditable) return false;
        return (collectionListBox.selectedItem.getAttribute('hasFeeds') == "true");
    }/*}}}*/
    

    // should probably stop using the big command updater and do specific 
    // small updates
    var collectionController = new CommandController({
        mNode: collectionListBox,
        mLibraryItem: $('flock_collectionLibrary'),
        isDebug: false,
        debugCommands: ["cmd_delete"],
        debugFromCommandset: "flock_collectionCommands",
        cmd_delete: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () { goDoCommand('cmd_collectionRemove'); }
        },/*}}}*/
        cmd_forceDelete: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () { goDoCommand('cmd_collectionForceRemove'); }
        },/*}}}*/
        cmd_collectionRemove: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.removeCollection(selected.id);
                this.mNode.selectedIndex = 0;
            }
        },/*}}}*/
        cmd_collectionForceRemove: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.removeCollection(selected.id, true);
                this.mNode.selectedIndex = 0;
            }
        },/*}}}*/
        cmd_collectionRename: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function (aEvt) {
                XXX('GOT AN EVVENET', aEvt);
                dd(aEvt);
                var selected = this.mNode.selectedItem;
                flock.favorites.renameCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionProperties: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.editCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionOpenInTabs: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem
                flock.favorites.openCollectionInTabs(selected.id);
            }
        },/*}}}*/
        cmd_collectionViewFeeds: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionViewFeedsInTab: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id, 'tab');
            }
        },/*}}}*/
        cmd_collectionViewFeedsInWindow: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id, 'window');
            }
        },/*}}}*/
        cmd_collectionRefreshFeeds: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.refreshFeedsForCollection(selected.id);
            }
        },/*}}}*/
    });
    
    collectionListBox.controllers.appendController(collectionController);
    
    // Popup Stuffs
    var collectionContext = new flock.xul.Popup($('collectionContext'), {/*{{{*/
        isDebug: true,
        onPopupShowing: function (aEvt) {
            flock_updateCommandset($('flock_collectionCommands'));
        },
    });/*}}}*/
    collectionContext.attach();
    

    // Collection Observer
    var collectionListBoxObserver = {/*{{{*/
        favTree: favTree,
        getSupportedFlavours: function (aFlavourSet) {
            aFlavourSet.appendFlavour("text/x-moz-url");
            aFlavourSet.appendFlavour("text/unicode");
            aFlavourSet.appendFlavour("application/x-moz-file");
        },
        canDropOnChild: function (aEvent, aTarget, aDragSession, aBoolVal) {
            var canDrop = (aTarget.getAttribute('dropable') != "false");
            aBoolVal.value = canDrop;
        },
        onContextClickOnChild: function (aEvent, aTarget) {
            flock_updateCommandset($('flock_collectionCommands'));
        },
        onSelectOnChild: function (aEvent, aTarget) {
            var newRef = aTarget.getAttribute('collection');
            if (newRef == "NC:HistoryRoot")
               this.favTree.setAttribute('datasources', 'rdf:history rdf:flock-favorites rdf:files rdf:localsearch');
            else
               this.favTree.setAttribute('datasources', 'rdf:flock-favorites rdf:history rdf:files rdf:localsearch');
            this.favTree.setAttribute('ref', newRef);
            flock_updateCommandset($('flock_collectionCommands'));
            flock_updateCommandset($('flock_favoriteCommands'));
        },
        onDropOnChild: function (aEvent, aTarget, aXferData, aDragSession) {
            var data = new DNDTransferSet({
                supportedFlavours: [
                    "text/x-moz-url", 
                    "text/unicode",
                    "application/x-moz-file"
                ],
                dragSession: aDragSession,
                isDebug: true
            });
            var ar = data.getDataAs("url");
            flock.favorites.addItemsToCollection(ar, aTarget.resource);
        },
        onDrop: function (aEvent, aTarget, aXferData, aDragSession) {
            var data = new DNDTransferSet({
                supportedFlavours: [
                    "text/x-moz-url", 
                    "text/unicode",
                    "application/x-moz-file"
                ],
                dragSession: aDragSession,
                isDebug: false
            });
            var ar = data.getDataAs("url");
            flock.favorites.createCollectionFrom(ar);
        },
    };/*}}}*/
    collectionListBox.addObserver(collectionListBoxObserver);
    
    // Select the initial item
    collectionListBox.selectedIndex = 0;
    collectionListBox.focus();
}


// Initializing the right side.
function init_right() {
    var tree = $('flock_favoriteView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();

    //// XXX andy: REFACTOR ME
    //var feedsSelected = function () {[>{{{<]
    //    var selectedItems = flock_getTreeSelection(tree, ["URL"]);
    //    for (var i = 0; i < selectedItems.length; ++i) {
    //        var item = selectedItems[i];
    //        if (flock.favorites.isFeed(item.URL)) return true;
    //        if (flock.favorites.favoriteHasFeeds(item.URL)) return true;
    //    }
    //    return false;    
    //};[>}}}<]
    
    treeController = new CommandController({
        isDebug: false,
        debugCommands: ["cmd_return", "cmd_delete"],
        debugFromCommandset: 'flock_favoriteCommands',
        cmd_delete: function () { goDoCommand('cmd_favoriteRemove'); },
        cmd_forceDelete: function () { goDoCommand('cmd_favoriteForceRemove'); },
        cmd_return: function () { goDoCommand('cmd_favoriteOpen'); },
        cmd_favoriteRemove: {/*{{{*/
            isEnabled: function () {
                return (tree.ref != "NC:HistoryRoot");
            },
            exec: function () {
                var selected = favoritesTree.selectedItems;
		var strBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService();
		strBundleService = strBundleService.QueryInterface(Components.interfaces.nsIStringBundleService);
		var stringBundle = strBundleService.createBundle("chrome://flock/locale/favorites/favoritesManager.properties");
                var message =  stringBundle.GetStringFromName("flock.favorites.manager.confirm1");
                if (selected.length > 1) {
                    if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                        message = stringBundle.GetStringFromName("flock.favorites.manager.confirm2");
                    }
                    else {
                        message = stringBundle.GetStringFromName("flock.favorites.manager.confirm3");
                    }
                } 
                else {
                    if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                        message = stringBundle.GetStringFromName("flock.favorites.manager.confirm4");
                    }
                    else {
                        message = stringBundle.GetStringFromName("flock.favorites.manager.confirm5");
                    }
                }
                
                var rv = flock.dialog.confirm(message);
                if (!rv) return
                
                goDoCommand('cmd_favoriteForceRemove');
            }
        },/*}}}*/ 
        cmd_favoriteForceRemove: {/*{{{*/
            isEnabled: function () {
                return (tree.ref != "NC:HistoryRoot");
            },
            exec: function () {
                XXX('MEEE');
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ["URL"]);
                // attempted optimization
                
                tree.view.selection.selectEventsSuppressed = true;
                tree.database.beginUpdateBatch();
                for (var i = 0; i < selected.length; ++i) {
                    var row = selected[i];
                    if (row.parentIndex != -1) {
                        // remove from a favorite
                        flock.favorites.removeItemFromParent(
                            row.URL, 
                            tree.builder.getResourceAtIndex(row.parentIndex)
                        );
                    }
                    else {
                        if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                            // remove from library
                            flock.favorites.removeItemFromParent(row.URL);
                        }
                        else {
                            flock.favorites.removeItemFromParent(row.URL, tree.ref);
                        }
                    }
                }
                tree.database.endUpdateBatch();
                tree.view.selection.selectEventsSuppressed = false;
            }
        },/*}}}*/ 
        cmd_favoriteRename: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['URL', 'Name']);
            flock.favorites.renameItem({
                url: selected[0].URL,
                name: selected[0].Name
            });
        },/*}}}*/
        cmd_favoriteProperties: function () {/*{{{*/
            var selected = favoritesTree.selectedItems;
            if (selected.length>1) {
                var items = [];
                for (var i=0; i<selected.length; i++) {
                    items.push( selected[i].URL );
                }
                flock.favorites.editMultipleItems( items );
            } else {
                flock.favorites.editItem( {url:selected[0].URL} );
            }
        },/*}}}*/
        cmd_favoriteOpen: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['URL']);
            if (flock.favorites.isFeed(selected[0].URL)) {
                flock.browser.openFeeds([selected[0].URL]);
            }
            else {
                flock.browser.open(selected[0].URL);
            }
        },/*}}}*/
        cmd_favoriteOpenInTab: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['URL']);
            if (flock.favorites.isFeed(selected[0].URL)) {
                flock.browser.openFeeds([selected[0].URL], 'tab');
            }
            else {
                flock.browser.open(selected[0].URL, 'tab');
            }
        },/*}}}*/
        cmd_favoriteOpenInWindow: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['URL']);
            if (flock.favorites.isFeed(selected[0].URL)) {
                flock.browser.openFeeds([selected[0].URL], 'window');
            }
            else {
                flock.browser.open(selected[0].URL, 'window');
            }
        },/*}}}*/
        cmd_favoriteOpenAllInTabs: function () {/*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['URL']);
            for (var i = 0; i < selected.length; ++i) {
                if (flock.favorites.isFeed(selected[i].URL)) {
                    flock.browser.openFeeds([selected[i].URL], 'tab');
                }
                else {
                    flock.browser.open(selected[i].URL, 'tab');
                }
            }
        },/*}}}*/
        cmd_collectionCreate: function () {/*{{{*/
            flock.favorites.createCollection();
            /// XXX - upon creating a collection if any favorites are selected 
            /// they should be added to the new collection
        },/*}}}*/
        cmd_favoriteViewFeeds: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ['URL']);
                var feeds = selected.map(function (aVal) {
                    return aVal.URL;
                });
                flock.favorites.viewFeeds(feeds);
            }
        },/*}}}*/
        cmd_favoriteViewFeedsInTab: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ['URL']);
                var feeds = selected.map(function (aVal) {
                    return aVal.URL;
                });
                flock.favorites.viewFeeds(feeds, 'tab');
            }
        },/*}}}*/
        cmd_favoriteViewFeedsInWindow: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                //var selected = flock_getTreeSelection(tree, ['URL']);
                var feeds = selected.map(function (aVal) {
                    return aVal.URL;
                });
                flock.favorites.viewFeeds(feeds, 'window');
            }
        },/*}}}*/
        cmd_favoriteRefreshFeeds: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                //var selected = flock_getTreeSelection(tree, ['URL']);
                var feeds = selected.map(function (aVal) {
                    return aVal.URL;
                });
                flock.favorites.refreshFeeds(feeds);
            }
        },/*}}}*/
    });
    // Add all the controllers to the right places/*{{{*/
    tree.controllers.appendController(treeController);
    /*}}}*/

    // Dispatch Clicks/*{{{*/
    var favoritesTreeClicker = new flock.xul.TreeClicker(tree, {
        isDebug: false,
    });
    favoritesTreeClicker.attach();/*}}}*/


    var favoritesTree = new flock.xul.RDFTree(tree, {
        isDebug: false,
        
        // the checks
        isEditable: function (aResource) {/*{{{*/
            return true;
        },/*}}}*/
        
        get feedsSelected() {/*{{{*/
            if (!this.selectedItems) {
                this.selectedItems = flock_getTreeSelection(this.mNode, ['URL', 'Name']);
            }
            for (var i = 0; i < this.selectedItems.length; ++i) {
                var item = this.selectedItems[i];
                if (flock.favorites.isFeed(item.URL)) return true;
                if (flock.favorites.favoriteHasFeeds(item.URL)) return true;
            }
            return false;    
        },/*}}}*/
        clearDragData: function () {/*{{{*/
            XXX('clearingDragData');
            this.dragData = null;
            this.newDragData = true;
            
            this.dragProps = {};
        },/*}}}*/
        // nsIXULTreeBuilderObserver overrides
        //canDrop: function (aIndex, aOrientation) {[>{{{<]
        //    // Use cases:[>{{{<]
        //    //  Dropping a Favorite / URL into currently view selection - OK
        //    //  Dropping a Feed into the currently viewed selection - OK
        //    //  Dropping a Favorite / URL into another Favorite - FAIL
        //    //  Dropping a Feed into another Favorite - FAIL
        //    //  Dropping a Feed into its own Favorite - OK
        //    //  Dropping ON anything - FAIL
        //    //  Dropping into a parent that is not editable - FAIL
        //    //  Dropping into a sorted collection from the same collection - FAIL
        //    //  Dropping into a sorted collection from a different collection - OK
        //    // --[>}}}<]
            
            
        //    // Cannot drop on things yet
        //    if (aOrientation == this.DROP_ON) return false;
            
            
        //    var currentDragSession = flock_getDragSession();
        //    XXX('CURRENT DRAG SESSION', currentDragSession);
        //    // XXX andy: what? drag sessions do not invalidate?
        //    //if (this.dragSession != currentDragSession) {
        //        this.clearDragData();
        //        // Grab the drag session
        //        if (!currentDragSession) {
        //            XXX('No drag session');
        //            return false;
        //        }
        //        this.dragSession = currentDragSession;
                
        //        // Grab the data to be dropped
        //        var droppedData = new DNDTransferSet({
        //            supportedFlavours: ["text/x-moz-url", "text/unicode"],
        //            dragSession: this.dragSession,
        //            isDebug: false
        //        });
        //        this.dragData = droppedData.getDataAs("url");
        //    //}
    
        //    // Grab the place we are dropping it
        //    var indexParentRsrc = this.getParentResource(aIndex);
        //    var indexParent = flock.favorites.getCollection(indexParentRsrc);
        //    if (!indexParent) indexParent = flock.favorites.getFavorite(indexParentRsrc);
        //    //if (!indexParent) return false;
            
        //    if (this.newDragData) {
        //        this.dragData = this.dragData.map(function (aVal) {
        //            if (this.dragProps['invalidDrop']) return;
        //            var fav = flock.favorites.getFavorite(aVal);
        //            if (!fav) {
        //                this.dragProps['invalidDrop'] = true;
        //                return;
        //            }
        //            fav.load();
        //            return fav;
        //        }, this);
        //        this.newDragData = false;
        //    }
            
        //    if (this.dragProps['invalidDrop']) {
        //        return false;
        //    }
        //    var dropTargetRsrc = this.mNode.builder.getResourceAtIndex(aIndex);
        //    var dropTarget = flock.favorites.getFeed(dropTargetRsrc);
        //    if (!dropTarget) dropTarget = flock.favorites.getFavorite(dropTargetRsrc);
            
        //    for (var i = 0; i < this.dragData.length; ++i) {
        //        var droppedItem = this.dragData[i];
                
        //        if (flock.favorites.isFeed(dropTarget)) {
        //            if (flock.favorites.isFeed(droppedItem)
        //                && flock.favorites.isItemInParent(droppedItem, indexParent)) {
        //                continue;   // return true;
        //            }
        //            return false;
        //        }
        //    }
        //    if (flock.favorites.isFavorite(dropTarget)) {
        //        if (aOrientation == this.DROP_BEFORE) {
        //            var dropParentRsrc = this.getParentResource(aIndex - 1);
        //        }
        //        else if (aOrientation == this.DROP_AFTER) {
        //            var dropParentRsrc = this.getParentResource(aIndex + 1);
        //        }
        //    }
        //    var dropParent = flock.favorites.getCollection(dropParentRsrc);
        //    if (!dropParent) {
        //        // we are in the library
        //        for (var i = 0; i < this.dragData.length; ++i) {
        //            var droppedItem = this.dragData[i];
        //            if isFavo
        //        }
        //    }
        //    for (var i = 0; i < this.dragData.length; ++i) {
        //        var droppedItem = this.dragData[i];
        //        if (flock.favorites.isItemInParent(droppedItem, dropParent)
        //            && this.isSorted()) {
        //            return false;
        //        }
        //        // just for kicks...
        //        //return true;
        //    }
        //    return true;
        //},[>}}}<]
        canDrop: function (aIndex, aOrientation) {/*{{{*/
            // Use cases:/*{{{*/
            //  Dropping a Favorite / URL into currently view selection - OK
            //  Dropping a Feed into the currently viewed selection - OK
            //  Dropping a Favorite / URL into another Favorite - FAIL
            //  Dropping a Feed into another Favorite - FAIL
            //  Dropping a Feed into its own Favorite - OK
            //  Dropping ON anything - FAIL
            //  Dropping into a parent that is not editable - FAIL
            //  Dropping into a sorted collection from the same collection - FAIL
            //  Dropping into a sorted collection from a different collection - OK
            // --/*}}}*/
            
            // Cannot drop on things yet
            if (aOrientation == this.DROP_ON) return false;
            
            
            // Grab the drag session
            var dragSession = flock_getDragSession();
            if (!dragSession) {
                XXX('No drag session');
                return;
            }
            
            // Grab the data to be dropped
            var droppedData = new DNDTransferSet({
                supportedFlavours: ["text/x-moz-url", "text/unicode"],
                dragSession: dragSession,
                isDebug: false
            });
            var data = droppedData.getDataAs("url");

            // Grab the place we are dropping it
            var dropTarget = this.mNode.builder.getResourceAtIndex(aIndex);

            // Iterate over the data to make sure it can all be dropped on
            // the target
            for (var i = 0; i < data.length; ++i) {
                var droppedItem = data[i];
                if (!flock.favorites.isFavorite(droppedItem)) return false;
                // XXX andy: isEditable does not really do anything for
                //           for the moment, so we are just going to skip it
                //if (!this.isEditable(endParent)) return false;
            
                
                
                if (flock.favorites.isFeed(dropTarget)) {
                    if (flock.favorites.isFeed(droppedItem)
                        && flock.favorites.isItemInParent(droppedItem, this.getParentResource(aIndex))) {
                        continue;   // return true;
                    }
                    return false;
                }
                if (flock.favorites.isFavorite(dropTarget)) {
                    if (aOrientation == this.DROP_BEFORE) {
                        var dropParent = this.getParentResource(aIndex - 1);
                        // No ordering in Library
                        if (dropParent.ValueUTF8 == "http://flock.com/rdf#FavoritesRoot") {
                            return false;
                        }
                        if (flock.favorites.isFavorite(dropParent)) return false;
                        if (flock.favorites.isItemInParent(droppedItem, dropParent)
                            && this.isSorted()) {
                            return false;
                        }
                        continue;   // return true;
                    }
                    if (aOrientation == this.DROP_AFTER) {
                        var dropParent = this.getParentResource(aIndex + 1);
                        if (dropParent.ValueUTF8 == "http://flock.com/rdf#FavoritesRoot") {
                            return false;
                        }
                        if (flock.favorites.isFavorite(dropParent)) return false;
                        if (flock.favorites.isItemInParent(droppedItem, dropParent)
                            && this.isSorted()) {
                            return false;
                        }
                        continue;   // return true;
                    }
                }
                return false;
            }
            return true;
        },/*}}}*/
        onDrop: function (aRow, aOrientation) {/*{{{*/
            
            var endParent = this.getParentResource(aRow);
            //var dropIndex = aRow + aOrientation;
            
            // Get drag session
            var dragSession = flock_getDragSession();
            if (!dragSession) {
                XXX('No drag session');
                return;
            }

            // Get dropped data
            var droppedData = new DNDTransferSet({
                supportedFlavours: ["text/x-moz-url", "text/unicode", "application/x-moz-file"],
                dragSession: dragSession,
                isDebug: false
            });

            var data = droppedData.getDataAs("url");
            var lastIdx = null;
            for (var i = 0; i < data.length; ++i) {
                this.mNode.database.beginUpdateBatch();
                var droppedItem = data[i];
                
                // first, ensure that the item is added
                if (flock.favorites.isFeed(droppedItem.url)) {
                    droppedItem = flock.favorites.getOrCreateFeed({
                        url: droppedItem.url, 
                        name: droppedItem.name
                    });
                }
                else {
                    droppedItem = flock.favorites.getOrCreateFavorite({
                        url: droppedItem.url, 
                        name: droppedItem.name
                    });
                }
                
                //// At this point we are confident that droppedItem 
                //// is a resource
                //if (!this.isResource(droppedItem)) {
                //    XXX('!isResource');    
                //    continue;
                //}
                
                // Collections are not supported
                //if (0 && flock.favorites.isCollection(droppedItem)) {
                //    XXX('isCollection');    
                //    continue;
                //}
                
                // Alright, we are going to handle the drop, time to
                // figure out where we are actually dropping it
                var rowIndex = null;
                if (rowIndex == null) {
                    rowIndex = this.getIndexInParent(aRow, aOrientation);
                }
                
                
                if (!flock.favorites.isItemInParent(droppedItem, endParent)) {
                    droppedItem.rowIndex = -1;
                } else {
                    droppedItem.rowIndex = flock.favorites.getIndexInCollection(droppedItem, endParent);
                    droppedItem.rowIndex--;
                }
                
                
                if (lastIdx == null) {
                    var adjustedIndex = rowIndex;
                    XXX('DROP',  adjustedIndex, 'NO LAST IDX');
                    adjustedIndex += (aOrientation == this.DROP_BEFORE) ? 0 : 1;
                    XXX('DROP', adjustedIndex, 'ORIENT BEFORE?', (aOrientation == this.DROP_BEFORE));
                    adjustedIndex += (rowIndex > droppedItem.rowIndex) ? -1 : 0;
                    XXX('DROP', adjustedIndex, 'FROM BEFORE?', (rowIndex > droppedItem.rowIndex));
                }
                else {
                    var adjustedIndex = (rowIndex > droppedItem.rowIndex) ? lastIdx : lastIdx + 1;
                    XXX('DROP',  adjustedIndex, 'LAST IDX', lastIdx, 'FROM BEFORE?', (rowIndex > droppedItem.rowIndex));
                }
                XXX('DROP', "ON", rowIndex, aOrientation, "FROM ROW", droppedItem.rowIndex, "ADJUSTED", adjustedIndex, droppedItem.name);
                lastIdx = adjustedIndex;
                

                // Figure out if we are adding or reordering and do it
                // We check isFeed first because Feeds are also Favorites
                if (flock.favorites.isFeed(droppedItem)) {
                    XXX('IS FEED');
                    if (flock.favorites.isItemInParent(droppedItem, endParent)
                        && !this.isSorted(endParent)) {
                        flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex);
                    }
                    else if (!flock.favorites.isItemInParent(droppedItem, endParent)) {
                        // the situation that we are dropping inside a
                        // Favorite should be prevented by canDrop
                        if (this.isSorted(endParent)) {
                            flock.favorites.addItemToCollection(droppedItem, endParent);
                        }
                        else {
                            flock.favorites.addItemToCollection(droppedItem, endParent);
                            flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex + 1);
                        }
                    }
                }
                else if (flock.favorites.isFavorite(droppedItem)) {
                    XXX('IS FAV');
                    if (flock.favorites.isItemInParent(droppedItem, endParent)
                        && !this.isSorted(endParent)) {
                        XXX('IN PARENT', 'NOT SORTED');
                        flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex);
                    }
                    else if (!flock.favorites.isItemInParent(droppedItem, endParent)) {
                        XXX('NOT IN PARENT');
                        dd(endParent);
                        if (this.isSorted(endParent)) {
                            flock.favorites.addItemToCollection(droppedItem, endParent);
                        }
                        else {
                            flock.favorites.addItemToCollection(droppedItem, endParent);
                            flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex + 1);
                        }
                    }
                    else {
                        XXX('IN PARENT', 'SORTED');
                    }
                }
                this.mNode.database.endUpdateBatch();
            }
        },/*}}}*/
        onSelectionChanged: function () {/*{{{*/
            //this.mNode.focus();
            this.selectedItems = flock_getTreeSelection(this.mNode, ['URL', 'Name']);
            flock_updateCommandset($('flock_favoriteCommands'));
        },/*}}}*/
        onPerformActionOnCell: function (aAction, aRow, aCol) {/*{{{*/
            switch (aAction) {
                case "onDblClick":
					switch (aCol) {
						case 'sharing':
							break;
						default:
							goDoCommand('cmd_favoriteOpen');
							break;
					}
                    break;
                case "onMdlClick":
                case "onDblCtrlClick":
                case "onDblMetaClick":
                    goDoCommand('cmd_favoriteOpenInTab');
                    break;
            }
        },/*}}}*/
        onCycleCell: function (aRow, aCol) {/*{{{*/
            // ignore children
            if (this.getParentIndex(aRow) != -1) return;
            
            // privacy does not matter with no service
            if (!flock.favorites.service.getWebServiceEnabled()) return;

            // alright, get it
            var rsrc = this.getResourceAtIndex(aRow);
            var fav = flock.favorites.getFavorite(rsrc);
            fav.load();
            if (fav.local) {
                flock.favorites.editItem(fav, {local: false});
            }
            else {
                if (!fav.private && flock.favorites.supportsField('private')) {
                    flock.favorites.editItem(fav, {private: true});
                }
                else if (fav.private || !flock.favorites.supportsField('private')) {
                    flock.favorites.editItem(fav, {private: false, local: true});
                }
            }
            this.mNode.builder.rebuild();
        },/*}}}*/
    });
    favoritesTree.attach();

    // Context Menu
    var favContext = new flock.xul.SwitchingPopup($('favoriteContext'), {
        isDebug: true,
        popupSet: "favoriteContextPopupSet",
        onPopupShowing: function (aEvt) {/*{{{*/
            //tree.focus();
            flock_updateCommandset($('flock_favoriteCommands'));
            var count = tree.view.selection.count;
            if (count == 0) {
                return false;
            }
            else if (count == 1) {
                this.switchTo("favoriteItemSelectedContext");
            }
            else {
                this.switchTo("favoriteMultipleItemsSelectedContext");
            }
            return true;
        },/*}}}*/
    });
    favContext.attach();
    
    var searchbox = $('favoritesManagerSearchbox');
    var searchboxObserver = {
            mOuter: this,
            mInput: searchbox,
            mTree: tree,
            //mClearButton: $('favoritesManagerClearSearch'),
            mTreeTemplate: $('favoriteViewTemplate'),
            _searchResults: null,
            get searchResults() {/*{{{*/
                return this._searchResults;
            },/*}}}*/
            set searchResults(aDataSource) {/*{{{*/
                if (this._searchResults != null) {
                    flock.rdf.removeDataSources(this.mTree, 
                                                [this._searchResults]);
                }
                if (aDataSource == null) {
                    // we are clearing the tree
                    this.unfilterTree();
                    this._searchResults = null;
                    //flock.xul.hide(this.mClearButton);
                }
                else {
                    //flock.xul.show(this.mClearButton);
                    this._searchResults = aDataSource;
                    flock.rdf.addDataSources(this.mTree,
                                             [this._searchResults]);
                    this.filterTree();
                    dump_rdf(this._searchResults);
                }
                this.mTree.builder.rebuild();
            },/*}}}*/
            filterTree: function () {/*{{{*/
                // find all the conditions we need to add a rule to
                var searchConditions = document.getElementsByAttribute('favoritesSearch', 'conditions');
                for (var i = 0; i < searchConditions.length; i++) {
                    var conditions = searchConditions[i];
                    // XXX andy: i don't think we actually need to remove old filters,
                    //           they'll get removed eventually via unfilterTree anyway
                    //           and i don't think they pose a more serious performance
                    //           threat than recursing over the items every time like
                    //           this could is doing.
                    //// find old search rules to remove
                    //for (var j = 0; j < conditions.childNodes.length; j++) {
                    //    var child = conditions.childNodes[j];
                    //    if (child.getAttribute ('predicate') == 
                    //            'http://flock.com/rdf#searchresult') {
                    //        // this is one we want to remove
                    //        conditions.removeChild (child);
                    //   }
                    //}
                    // create a rule to match only search results
                    var triple = flock.xul.createElement('triple', {
                        subject: "?uri",
                        predicate: "http://flock.com/rdf#searchresult",
                        object: "true",
                        favoritesSearch: "filter"   
                        
                    });

                    // and add it to the condition
                    conditions.appendChild(triple);
                }
            },/*}}}*/
            unfilterTree: function () {/*{{{*/
                // find all the filters we need to remove
                var searchFilters = document.getElementsByAttribute('favoritesSearch', 'filter');
                searchFilters = flock.lang.toArray(searchFilters);
                searchFilters.forEach(dojo.dom.removeNode);
            },/*}}}*/
            onEnter: function () {/*{{{*/
                this.mInput.clearInputTimer();
                this.search();
            },/*}}}*/
            onEscape: function () {/*{{{*/
                XXX('onEscape');
                this.mInput.value = "";
                this.mInput.clearInputTimer();
                this.searchResults = null;
            },/*}}}*/
            onInputDelayed: function (aEvent) {/*{{{*/
                XXX('SO VERY HAPPY TO BEH ERE');
                if (this.mInput.value.length < this.mInput.minChars) {
                    this.unfilterTree();
                    this.searchResults = null;
                    return;
                }
                this.search();
            },/*}}}*/
            search: function () {/*{{{*/
                XXX('SEARCHIPOO');
                var _this = this;
                var callback = new flock.search.SearchCallback({
                    onResult: function (aData) {  
                        _this.searchResults = aData;
                    }
                });
                flock.search.search(this.mInput.value, 100, callback);
            },/*}}}*/

    }
    searchbox.addObserver(searchboxObserver);
    dojo.event.connect($('favoritesManagerClearSearch'), 'onclick',
                       searchboxObserver, 'onEscape');
    
}
