// the Flock default favorites - inspired by prefs.js
//
// Syntax:
//  favorite (url, {name: 'foo', description: 'bar', tags: 'hello, world'})
//  feed (favoriteurl, feedurl, name)
//  collection (name, [faveurl1, faveurl2, faveurl3])
//  defaultCollection (name)

favorite ('http://www.flock.com/start/', 
         { name: 'Home', tags: 'flock,flockstart', });
favorite ('http://www.flock.com/tour/', 
         { name: 'Tour', tags: 'flock,flockstart', });
favorite ('http://extend.flock.com/', 
         { name: 'Extend', tags: 'flock,flockstart', });
favorite ('http://feeds.flock.com/', 
         { name: 'Flock Radio', tags: 'flock,flockstart', });
feed ('http://feeds.flock.com/', 'http://feeds.flock.com/feed.rss', 'RSS 2.0');
favorite ('http://www.flock.com/feedback/', 
         { name: 'Feedback', tags: 'flock,flockstart,feedback', });

collection ('Flock Faves', ['http://www.flock.com/start/',
                            'http://www.flock.com/tour/',
                            'http://extend.flock.com/',
                            'http://feeds.flock.com/',
                            'http://www.flock.com/feedback/']);

favorite ('http://nytimes.com/', { name: 'NY Times', tags: 'news', });
feed ('http://nytimes.com/', 
        'http://www.nytimes.com/services/xml/rss/nyt/HomePage.xml', 'RSS');
favorite ('http://digg.com/', { name: 'Digg', tags: 'news', });
feed ('http://digg.com/', 'http://digg.com/rss/index.xml', 'digg');
favorite ('http://slashdot.org/', { name: 'Slashdot', tags: 'news', });
feed ('http://slashdot.org/', 'http://rss.slashdot.org/Slashdot/slashdot', 
        'Slashdot RSS');

collection ('News', ['http://nytimes.com/',
                     'http://digg.com/',
                     'http://slashdot.org/']);

defaultCollection ('Flock Faves');
