// vim: foldmethod=marker

flock.feed = {/*{{{*/
    // para todo mal
    // mezcal
    // y para todo bien
    // tambien
};/*}}}*/


flock.feed.__defineGetter__('service', function () {/*{{{*/
    if (flock.feed._service) return flock.feed._service;
    flock.feed._service = flock.xpcom.getService(
        '@flock.com/feed-service;1',
        'flockIFeedService'
    );
    return flock.feed._service;
});/*}}}*/

flock.feed.refreshFeeds = function (aFeeds) {/*{{{*/
    aFeeds.forEach(function (aVal) {
            XXX('REFRESHING FEED', aVal);
            flock.feed.service.refreshFeed(aVal);   
        });
}/*}}}*/


// XXX andy: big ugly hack
flock.feed.getPostsForFeed = function (aUrl) {/*{{{*/
    flock.deprecated("flock.feed.getPostsForFeed is deprecated, please use flock.feed.getFeedData(url) instead");
    flock.require('flock.common.rdf');
    flock.require('flock.contrib.rdfds');
    var feedDS = flock.feed.service.getFeed(aUrl);
    //flock.rdf.dump(feedDS);
    var ds = new RDFDataSource();
    ds.Init(feedDS);
    var node = ds.getNode('urn:flock:feed:' + aUrl);
    var children = node.getChildren();
    var out = [];
    while (children.hasMoreElements()) {
        var item = children.getNext();
        var props = item.getProperties();
        while(props.hasMoreElements()) {
            var prop = props.getNext();
        }
        var url = item.getTarget('http://flock.com/rdf#link');
        var name = item.getTarget('http://flock.com/rdf#title');
        out.push({url: url.getValue(), name: name.getValue()});
    }
    return out;
}/*}}}*/
